import { LayoutChangeEvent, Animated } from 'react-native';
import type { ReactElement } from 'react';
import type { TabScreenProps } from './TabScreen';
import type { Theme } from 'react-native-paper/lib/typescript/types';
import type { IconPosition, Mode } from './utils';
export default function TabsHeaderItem({ tab, tabIndex, active, goTo, onTabLayout, activeColor, textColor, theme, position, offset, childrenCount, uppercase, mode, iconPosition, showTextLabel, topTextStyle, }: {
    tab: ReactElement<TabScreenProps>;
    tabIndex: number;
    active: boolean;
    goTo: (index: number) => void;
    onTabLayout: (index: number, e: LayoutChangeEvent) => void;
    activeColor: string;
    textColor: string;
    theme: Theme;
    position: Animated.Value | undefined;
    offset: Animated.Value | undefined;
    childrenCount: number;
    uppercase?: boolean;
    iconPosition?: IconPosition;
    showTextLabel?: boolean;
    mode: Mode;
    topTextStyle?: object;
}): JSX.Element;
